diff --git a/libavformat/mov.c b/libavformat/mov.c
index d19b213ffa..e006e77338 100644
--- a/libavformat/mov.c
+++ b/libavformat/mov.c
@@ -10031,7 +10085,7 @@ static int mov_read_close(AVFormatContext *s)
     av_freep(&mov->bitrates);
 
     for (i = 0; i < mov->frag_index.nb_items; i++) {
-        MOVFragmentStreamInfo *frag = mov->frag_index.item[i].stream_info;
+        MOVFragmentStreamInfo* frag = mov->frag_index.item[i].stream_info;
         for (j = 0; j < mov->frag_index.item[i].nb_stream_info; j++) {
             mov_free_encryption_index(&frag[j].encryption_index);
         }
@@ -10045,7 +10099,6 @@ static int mov_read_close(AVFormatContext *s)
         if (!mov->heif_item[i])
             continue;
         av_freep(&mov->heif_item[i]->name);
-        av_freep(&mov->heif_item[i]->iref_list);
         av_freep(&mov->heif_item[i]->icc_profile);
         av_freep(&mov->heif_item[i]);
     }
@@ -10056,17 +10109,18 @@ static int mov_read_close(AVFormatContext *s)
         av_freep(&mov->heif_grid[i].tile_item_list);
     }
     av_freep(&mov->heif_grid);
+    av_freep(&mov->thmb_item_id);
 
     return 0;
 }
 
-static int tmcd_is_referenced(AVFormatContext *s, int tmcd_id)
+static int tmcd_is_referenced(AVFormatContext* s, int tmcd_id)
 {
     int i;
 
     for (i = 0; i < s->nb_streams; i++) {
-        AVStream *st = s->streams[i];
-        MOVStreamContext *sc = st->priv_data;
+        AVStream* st = s->streams[i];
+        MOVStreamContext* sc = st->priv_data;
 
         if (st->codecpar->codec_type == AVMEDIA_TYPE_VIDEO &&
             sc->timecode_track == tmcd_id)
@@ -10076,16 +10130,16 @@ static int tmcd_is_referenced(AVFormatContext *s, int tmcd_id)
 }
 
 /* look for a tmcd track not referenced by any video track, and export it globally */
-static void export_orphan_timecode(AVFormatContext *s)
+static void export_orphan_timecode(AVFormatContext* s)
 {
     int i;
 
     for (i = 0; i < s->nb_streams; i++) {
-        AVStream *st = s->streams[i];
+        AVStream* st = s->streams[i];
 
-        if (st->codecpar->codec_tag  == MKTAG('t','m','c','d') &&
+        if (st->codecpar->codec_tag == MKTAG('t', 'm', 'c', 'd') &&
             !tmcd_is_referenced(s, i + 1)) {
-            AVDictionaryEntry *tcr = av_dict_get(st->metadata, "timecode", NULL, 0);
+            AVDictionaryEntry* tcr = av_dict_get(st->metadata, "timecode", NULL, 0);
             if (tcr) {
                 av_dict_set(&s->metadata, "timecode", tcr->value, 0);
                 break;
@@ -10094,7 +10148,7 @@ static void export_orphan_timecode(AVFormatContext *s)
     }
 }
 
-static int read_tfra(MOVContext *mov, AVIOContext *f)
+static int read_tfra(MOVContext* mov, AVIOContext* f)
 {
     int version, fieldlength, i, j;
     int64_t pos = avio_tell(f);
@@ -10114,17 +10168,18 @@ static int read_tfra(MOVContext *mov, AVIOContext *f)
     for (i = 0; i < item_count; i++) {
         int64_t time, offset;
         int index;
-        MOVFragmentStreamInfo * frag_stream_info;
+        MOVFragmentStreamInfo* frag_stream_info;
 
         if (avio_feof(f)) {
             return AVERROR_INVALIDDATA;
         }
 
         if (version == 1) {
-            time   = avio_rb64(f);
+            time = avio_rb64(f);
             offset = avio_rb64(f);
-        } else {
-            time   = avio_rb32(f);
+        }
+        else {
+            time = avio_rb32(f);
             offset = avio_rb32(f);
         }
 
@@ -10149,7 +10204,7 @@ static int read_tfra(MOVContext *mov, AVIOContext *f)
     return 0;
 }
 
-static int mov_read_mfra(MOVContext *c, AVIOContext *f)
+static int mov_read_mfra(MOVContext* c, AVIOContext* f)
 {
     int64_t stream_size = avio_size(f);
     int64_t original_pos = avio_tell(f);
@@ -10165,7 +10220,7 @@ static int mov_read_mfra(MOVContext *c, AVIOContext *f)
         av_log(c->fc, AV_LOG_DEBUG, "doesn't look like mfra (unreasonable size)\n");
         goto fail;
     }
-    if ((seek_ret = avio_seek(f, -((int64_t) c->mfra_size), SEEK_CUR)) < 0) {
+    if ((seek_ret = avio_seek(f, -((int64_t)c->mfra_size), SEEK_CUR)) < 0) {
         ret = seek_ret;
         goto fail;
     }
@@ -10189,18 +10244,18 @@ fail:
     seek_ret = avio_seek(f, original_pos, SEEK_SET);
     if (seek_ret < 0) {
         av_log(c->fc, AV_LOG_ERROR,
-               "failed to seek back after looking for mfra\n");
+            "failed to seek back after looking for mfra\n");
         ret = seek_ret;
     }
     return ret;
 }
 
-static int set_icc_profile_from_item(AVPacketSideData **coded_side_data, int *nb_coded_side_data,
-                                     const HEIFItem *item)
+static int set_icc_profile_from_item(AVPacketSideData** coded_side_data, int* nb_coded_side_data,
+    const HEIFItem* item)
 {
-    AVPacketSideData *sd = av_packet_side_data_new(coded_side_data, nb_coded_side_data,
-                                                   AV_PKT_DATA_ICC_PROFILE,
-                                                   item->icc_profile_size, 0);
+    AVPacketSideData* sd = av_packet_side_data_new(coded_side_data, nb_coded_side_data,
+        AV_PKT_DATA_ICC_PROFILE,
+        item->icc_profile_size, 0);
     if (!sd)
         return AVERROR(ENOMEM);
 
@@ -10209,14 +10264,14 @@ static int set_icc_profile_from_item(AVPacketSideData **coded_side_data, int *nb
     return 0;
 }
 
-static int set_display_matrix_from_item(AVPacketSideData **coded_side_data, int *nb_coded_side_data,
-                                        const HEIFItem *item)
+static int set_display_matrix_from_item(AVPacketSideData** coded_side_data, int* nb_coded_side_data,
+    const HEIFItem* item)
 {
-    int32_t *matrix;
-    AVPacketSideData *sd = av_packet_side_data_new(coded_side_data,
-                                                   nb_coded_side_data,
-                                                   AV_PKT_DATA_DISPLAYMATRIX,
-                                                   9 * sizeof(*matrix), 0);
+    int32_t* matrix;
+    AVPacketSideData* sd = av_packet_side_data_new(coded_side_data,
+        nb_coded_side_data,
+        AV_PKT_DATA_DISPLAYMATRIX,
+        9 * sizeof(*matrix), 0);
     if (!sd)
         return AVERROR(ENOMEM);
 
@@ -10230,11 +10285,11 @@ static int set_display_matrix_from_item(AVPacketSideData **coded_side_data, int
     return 0;
 }
 
-static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
-                           AVStreamGroupTileGrid *tile_grid)
+static int read_image_grid(AVFormatContext* s, const HEIFGrid* grid,
+    AVStreamGroupTileGrid* tile_grid)
 {
-    MOVContext *c = s->priv_data;
-    const HEIFItem *item = grid->item;
+    MOVContext* c = s->priv_data;
+    const HEIFItem* item = grid->item;
     int64_t offset = 0, pos = avio_tell(s->pb);
     int x = 0, y = 0, i = 0;
     int tile_rows, tile_cols;
@@ -10252,9 +10307,6 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
         offset = c->idat_offset;
     }
 
-    if (offset > INT64_MAX - item->extent_offset)
-        return AVERROR_INVALIDDATA;
-
     avio_seek(s->pb, item->extent_offset + offset, SEEK_SET);
 
     avio_r8(s->pb);    /* version */
@@ -10263,11 +10315,26 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
     tile_rows = avio_r8(s->pb) + 1;
     tile_cols = avio_r8(s->pb) + 1;
     /* actual width and height of output image */
-    tile_grid->width  = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
+    tile_grid->width = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
     tile_grid->height = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
 
+    /* ICC profile */
+    if (item->icc_profile_size) {
+        int ret = set_icc_profile_from_item(&tile_grid->coded_side_data,
+            &tile_grid->nb_coded_side_data, item);
+        if (ret < 0)
+            return ret;
+    }
+    /* rotation */
+    if (item->rotation || item->hflip || item->vflip) {
+        int ret = set_display_matrix_from_item(&tile_grid->coded_side_data,
+            &tile_grid->nb_coded_side_data, item);
+        if (ret < 0)
+            return ret;
+    }
+
     av_log(c->fc, AV_LOG_TRACE, "grid: grid_rows %d grid_cols %d output_width %d output_height %d\n",
-           tile_rows, tile_cols, tile_grid->width, tile_grid->height);
+        tile_rows, tile_cols, tile_grid->width, tile_grid->height);
 
     avio_seek(s->pb, pos, SEEK_SET);
 
@@ -10278,7 +10345,7 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
         return AVERROR_INVALIDDATA;
 
     for (int i = 0; i < tile_cols; i++)
-        tile_grid->coded_width  += grid->tile_item_list[i]->width;
+        tile_grid->coded_width += grid->tile_item_list[i]->width;
     for (int i = 0; i < size; i += tile_cols)
         tile_grid->coded_height += grid->tile_item_list[i]->height;
 
@@ -10293,9 +10360,9 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
             if (i == tile_grid->nb_tiles)
                 return AVERROR_INVALIDDATA;
 
-            tile_grid->offsets[i].idx        = grid->tile_idx_list[i];
+            tile_grid->offsets[i].idx = grid->tile_idx_list[i];
             tile_grid->offsets[i].horizontal = x;
-            tile_grid->offsets[i].vertical   = y;
+            tile_grid->offsets[i].vertical = y;
 
             x += grid->tile_item_list[i++]->width;
         }
@@ -10305,7 +10372,7 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
             return AVERROR_INVALIDDATA;
         }
 
-        x  = 0;
+        x = 0;
         y += grid->tile_item_list[left_col]->height;
     }
 
@@ -10317,11 +10384,11 @@ static int read_image_grid(AVFormatContext *s, const HEIFGrid *grid,
     return 0;
 }
 
-static int read_image_iovl(AVFormatContext *s, const HEIFGrid *grid,
-                           AVStreamGroupTileGrid *tile_grid)
+static int read_image_iovl(AVFormatContext* s, const HEIFGrid* grid,
+    AVStreamGroupTileGrid* tile_grid)
 {
-    MOVContext *c = s->priv_data;
-    const HEIFItem *item = grid->item;
+    MOVContext* c = s->priv_data;
+    const HEIFItem* item = grid->item;
     uint16_t canvas_fill_value[4];
     int64_t offset = 0, pos = avio_tell(s->pb);
     int ret = 0, flags;
@@ -10338,9 +10405,6 @@ static int read_image_iovl(AVFormatContext *s, const HEIFGrid *grid,
         offset = c->idat_offset;
     }
 
-    if (offset > INT64_MAX - item->extent_offset)
-        return AVERROR_INVALIDDATA;
-
     avio_seek(s->pb, item->extent_offset + offset, SEEK_SET);
 
     avio_r8(s->pb);    /* version */
@@ -10349,19 +10413,35 @@ static int read_image_iovl(AVFormatContext *s, const HEIFGrid *grid,
     for (int i = 0; i < 4; i++)
         canvas_fill_value[i] = avio_rb16(s->pb);
     av_log(c->fc, AV_LOG_TRACE, "iovl: canvas_fill_value { %u, %u, %u, %u }\n",
-           canvas_fill_value[0], canvas_fill_value[1],
-           canvas_fill_value[2], canvas_fill_value[3]);
+        canvas_fill_value[0], canvas_fill_value[1],
+        canvas_fill_value[2], canvas_fill_value[3]);
     for (int i = 0; i < 4; i++)
         tile_grid->background[i] = canvas_fill_value[i];
 
     /* actual width and height of output image */
-    tile_grid->width        =
-    tile_grid->coded_width  = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
-    tile_grid->height       =
-    tile_grid->coded_height = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
+    tile_grid->width =
+        tile_grid->coded_width = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
+    tile_grid->height =
+        tile_grid->coded_height = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
+
+    /* rotation */
+    if (item->rotation || item->hflip || item->vflip) {
+        int ret = set_display_matrix_from_item(&tile_grid->coded_side_data,
+            &tile_grid->nb_coded_side_data, item);
+        if (ret < 0)
+            return ret;
+    }
+
+    /* ICC profile */
+    if (item->icc_profile_size) {
+        int ret = set_icc_profile_from_item(&tile_grid->coded_side_data,
+            &tile_grid->nb_coded_side_data, item);
+        if (ret < 0)
+            return ret;
+    }
 
     av_log(c->fc, AV_LOG_TRACE, "iovl: output_width %d, output_height %d\n",
-           tile_grid->width, tile_grid->height);
+        tile_grid->width, tile_grid->height);
 
     tile_grid->nb_tiles = grid->nb_tiles;
     tile_grid->offsets = av_malloc_array(tile_grid->nb_tiles, sizeof(*tile_grid->offsets));
@@ -10371,13 +10451,13 @@ static int read_image_iovl(AVFormatContext *s, const HEIFGrid *grid,
     }
 
     for (int i = 0; i < tile_grid->nb_tiles; i++) {
-        tile_grid->offsets[i].idx        = grid->tile_idx_list[i];
+        tile_grid->offsets[i].idx = grid->tile_idx_list[i];
         tile_grid->offsets[i].horizontal = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
-        tile_grid->offsets[i].vertical   = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
+        tile_grid->offsets[i].vertical = (flags & 1) ? avio_rb32(s->pb) : avio_rb16(s->pb);
         av_log(c->fc, AV_LOG_TRACE, "iovl: stream_idx[%d] %u, "
-                                    "horizontal_offset[%d] %d, vertical_offset[%d] %d\n",
-               i, tile_grid->offsets[i].idx,
-               i, tile_grid->offsets[i].horizontal, i, tile_grid->offsets[i].vertical);
+            "horizontal_offset[%d] %d, vertical_offset[%d] %d\n",
+            i, tile_grid->offsets[i].idx,
+            i, tile_grid->offsets[i].horizontal, i, tile_grid->offsets[i].vertical);
     }
 
 fail:
@@ -10386,98 +10466,14 @@ fail:
     return ret;
 }
 
-static int mov_parse_exif_item(AVFormatContext *s,
-                               AVPacketSideData **coded_side_data, int *nb_coded_side_data,
-                               const HEIFItem *ref)
-{
-    MOVContext *c = s->priv_data;
-    AVPacketSideData *sd;
-    AVExifMetadata ifd = { 0 };
-    AVBufferRef *buf;
-    int64_t offset = 0, pos = avio_tell(s->pb);
-    unsigned orientation_id = av_exif_get_tag_id("Orientation");
-    int err;
-
-    if (!(s->pb->seekable & AVIO_SEEKABLE_NORMAL)) {
-        av_log(c->fc, AV_LOG_WARNING, "Exif metadata with non seekable input\n");
-        return AVERROR_PATCHWELCOME;
-    }
-    if (ref->is_idat_relative) {
-        if (!c->idat_offset) {
-            av_log(c->fc, AV_LOG_ERROR, "missing idat box required by the Exif metadata\n");
-            return AVERROR_INVALIDDATA;
-        }
-        offset = c->idat_offset;
-    }
-
-    buf = av_buffer_alloc(ref->extent_length);
-    if (!buf)
-        return AVERROR(ENOMEM);
-
-    if (offset > INT64_MAX - ref->extent_offset) {
-        err = AVERROR(ENOMEM);
-        goto fail;
-    }
-
-    avio_seek(s->pb, ref->extent_offset + offset, SEEK_SET);
-    err = avio_read(s->pb, buf->data, ref->extent_length);
-    if (err != ref->extent_length) {
-        if (err > 0)
-            err = AVERROR_INVALIDDATA;
-        goto fail;
-    }
-
-    // HEIF spec states that Exif metadata is informative. The irot item property is
-    // the normative source of rotation information. So we remove any Orientation tag
-    // present in the Exif buffer.
-    err = av_exif_parse_buffer(s, buf->data, ref->extent_length, &ifd, AV_EXIF_T_OFF);
-    if (err < 0) {
-        av_log(s, AV_LOG_ERROR, "Unable to parse Exif metadata\n");
-        goto fail;
-    }
-
-    err = av_exif_remove_entry(s, &ifd, orientation_id, 0);
-    if (err < 0)
-        goto fail;
-    else if (!err)
-        goto finish;
-
-    av_buffer_unref(&buf);
-    err = av_exif_write(s, &ifd, &buf, AV_EXIF_T_OFF);
-    if (err < 0)
-        goto fail;
-
-finish:
-    offset = AV_RB32(buf->data) + 4;
-    if (offset >= buf->size) {
-        err = AVERROR_INVALIDDATA;
-        goto fail;
-    }
-    sd = av_packet_side_data_new(coded_side_data, nb_coded_side_data,
-                                 AV_PKT_DATA_EXIF, buf->size - offset, 0);
-    if (!sd) {
-        err = AVERROR(ENOMEM);
-        goto fail;
-    }
-    memcpy(sd->data, buf->data + offset, buf->size - offset);
-
-    err = 0;
-fail:
-    av_buffer_unref(&buf);
-    av_exif_free(&ifd);
-    avio_seek(s->pb, pos, SEEK_SET);
-
-    return err;
-}
-
-static int mov_parse_tiles(AVFormatContext *s)
+static int mov_parse_tiles(AVFormatContext* s)
 {
-    MOVContext *mov = s->priv_data;
+    MOVContext* mov = s->priv_data;
 
     for (int i = 0; i < mov->nb_heif_grid; i++) {
-        AVStreamGroup *stg = avformat_stream_group_create(s, AV_STREAM_GROUP_PARAMS_TILE_GRID, NULL);
-        AVStreamGroupTileGrid *tile_grid;
-        const HEIFGrid *grid = &mov->heif_grid[i];
+        AVStreamGroup* stg = avformat_stream_group_create(s, AV_STREAM_GROUP_PARAMS_TILE_GRID, NULL);
+        AVStreamGroupTileGrid* tile_grid;
+        const HEIFGrid* grid = &mov->heif_grid[i];
         int err, loop = 1;
 
         if (!stg)
@@ -10491,16 +10487,16 @@ static int mov_parse_tiles(AVFormatContext *s)
             int k;
 
             for (k = 0; k < mov->nb_heif_item; k++) {
-                HEIFItem *item = mov->heif_item[k];
-                AVStream *st;
+                HEIFItem* item = mov->heif_item[k];
+                AVStream* st;
 
                 if (!item || item->item_id != tile_id)
                     continue;
                 st = item->st;
                 if (!st) {
                     av_log(s, AV_LOG_WARNING, "HEIF item id %d from grid id %d doesn't "
-                                              "reference a stream\n",
-                           tile_id, grid->item->item_id);
+                        "reference a stream\n",
+                        tile_id, grid->item->item_id);
                     ff_remove_stream_group(s, stg);
                     loop = 0;
                     break;
@@ -10530,8 +10526,8 @@ static int mov_parse_tiles(AVFormatContext *s)
             if (k == mov->nb_heif_item) {
                 av_assert0(loop);
                 av_log(s, AV_LOG_WARNING, "HEIF item id %d referenced by grid id %d doesn't "
-                                          "exist\n",
-                       tile_id, grid->item->item_id);
+                    "exist\n",
+                    tile_id, grid->item->item_id);
                 ff_remove_stream_group(s, stg);
                 loop = 0;
             }
@@ -10543,10 +10539,10 @@ static int mov_parse_tiles(AVFormatContext *s)
             continue;
 
         switch (grid->item->type) {
-        case MKTAG('g','r','i','d'):
+        case MKTAG('g', 'r', 'i', 'd'):
             err = read_image_grid(s, grid, tile_grid);
             break;
-        case MKTAG('i','o','v','l'):
+        case MKTAG('i', 'o', 'v', 'l'):
             err = read_image_iovl(s, grid, tile_grid);
             break;
         default:
@@ -10555,37 +10551,6 @@ static int mov_parse_tiles(AVFormatContext *s)
         if (err < 0)
             return err;
 
-        for (int j = 0; j < grid->item->nb_iref_list; j++) {
-            HEIFItem *ref = get_heif_item(mov, grid->item->iref_list[j].item_id);
-
-            av_assert0(ref);
-            switch(ref->type) {
-            case MKTAG('E','x','i','f'):
-                err = mov_parse_exif_item(s, &tile_grid->coded_side_data,
-                                             &tile_grid->nb_coded_side_data, ref);
-                if (err < 0 && (s->error_recognition & AV_EF_EXPLODE))
-                    return err;
-                break;
-            default:
-                break;
-            }
-        }
-
-        /* rotation */
-        if (grid->item->rotation || grid->item->hflip || grid->item->vflip) {
-            err = set_display_matrix_from_item(&tile_grid->coded_side_data,
-                                               &tile_grid->nb_coded_side_data, grid->item);
-            if (err < 0)
-                return err;
-        }
-
-        /* ICC profile */
-        if (grid->item->icc_profile_size) {
-            err = set_icc_profile_from_item(&tile_grid->coded_side_data,
-                                            &tile_grid->nb_coded_side_data, grid->item);
-            if (err < 0)
-                return err;
-        }
 
         if (grid->item->name)
             av_dict_set(&stg->metadata, "title", grid->item->name, 0);
@@ -10596,20 +10561,27 @@ static int mov_parse_tiles(AVFormatContext *s)
     return 0;
 }
 
-static int mov_parse_heif_items(AVFormatContext *s)
+static int mov_parse_heif_items(AVFormatContext* s)
 {
-    MOVContext *mov = s->priv_data;
+    MOVContext* mov = s->priv_data;
     int err;
 
     for (int i = 0; i < mov->nb_heif_item; i++) {
-        HEIFItem *item = mov->heif_item[i];
-        MOVStreamContext *sc;
-        AVStream *st;
+        HEIFItem* item = mov->heif_item[i];
+        MOVStreamContext* sc;
+        AVStream* st;
         int64_t offset = 0;
 
         if (!item)
             continue;
         if (!item->st) {
+            for (int j = 0; j < mov->nb_thmb_item; j++) {
+                if (item->item_id == mov->thmb_item_id[j]) {
+                    av_log(s, AV_LOG_ERROR, "HEIF thumbnail ID %d doesn't reference a stream\n",
+                        item->item_id);
+                    return AVERROR_INVALIDDATA;
+                }
+            }
             continue;
         }
         if (item->is_idat_relative) {
@@ -10622,43 +10594,24 @@ static int mov_parse_heif_items(AVFormatContext *s)
 
         st = item->st;
         sc = st->priv_data;
-        st->codecpar->width  = item->width;
+        st->codecpar->width = item->width;
         st->codecpar->height = item->height;
 
-        sc->sample_size  = sc->stsz_sample_size = item->extent_length;
+        sc->sample_size = sc->stsz_sample_size = item->extent_length;
         sc->sample_count = 1;
 
-        err = sanity_checks(s, sc, st->index);
+        err = sanity_checks(s, sc, item->item_id);
         if (err)
             return AVERROR_INVALIDDATA;
 
-        if (offset > INT64_MAX - item->extent_offset)
-            return AVERROR_INVALIDDATA;
-
         sc->chunk_offsets[0] = item->extent_offset + offset;
 
         if (item->item_id == mov->primary_item_id)
             st->disposition |= AV_DISPOSITION_DEFAULT;
 
-        for (int j = 0; j < item->nb_iref_list; j++) {
-            HEIFItem *ref = get_heif_item(mov, item->iref_list[j].item_id);
-
-            av_assert0(ref);
-            switch(ref->type) {
-            case MKTAG('E','x','i','f'):
-                err = mov_parse_exif_item(s, &st->codecpar->coded_side_data,
-                                             &st->codecpar->nb_coded_side_data, ref);
-                if (err < 0 && (s->error_recognition & AV_EF_EXPLODE))
-                    return err;
-                break;
-            default:
-                break;
-            }
-        }
-
         if (item->rotation || item->hflip || item->vflip) {
             err = set_display_matrix_from_item(&st->codecpar->coded_side_data,
-                                               &st->codecpar->nb_coded_side_data, item);
+                &st->codecpar->nb_coded_side_data, item);
             if (err < 0)
                 return err;
         }
@@ -10675,10 +10628,10 @@ static int mov_parse_heif_items(AVFormatContext *s)
     return 0;
 }
 
-static AVStream *mov_find_reference_track(AVFormatContext *s, AVStream *st,
-                                          int first_index)
+static AVStream* mov_find_reference_track(AVFormatContext* s, AVStream* st,
+    int first_index)
 {
-    MOVStreamContext *sc = st->priv_data;
+    MOVStreamContext* sc = st->priv_data;
 
     if (sc->tref_id < 0)
         return NULL;
@@ -10690,15 +10643,15 @@ static AVStream *mov_find_reference_track(AVFormatContext *s, AVStream *st,
     return NULL;
 }
 
-static int mov_parse_lcevc_streams(AVFormatContext *s)
+static int mov_parse_lcevc_streams(AVFormatContext* s)
 {
     int err;
 
     for (int i = 0; i < s->nb_streams; i++) {
-        AVStreamGroup *stg;
-        AVStream *st = s->streams[i];
-        AVStream *st_base;
-        MOVStreamContext *sc = st->priv_data;
+        AVStreamGroup* stg;
+        AVStream* st = s->streams[i];
+        AVStream* st_base;
+        MOVStreamContext* sc = st->priv_data;
         int j = 0;
 
         /* Find an enhancement stream. */
@@ -10713,7 +10666,7 @@ static int mov_parse_lcevc_streams(AVFormatContext *s)
             return AVERROR(ENOMEM);
 
         stg->id = st->id;
-        stg->params.lcevc->width  = st->codecpar->width;
+        stg->params.lcevc->width = st->codecpar->width;
         stg->params.lcevc->height = st->codecpar->height;
         st->codecpar->width = 0;
         st->codecpar->height = 0;
@@ -10740,34 +10693,34 @@ static int mov_parse_lcevc_streams(AVFormatContext *s)
     return 0;
 }
 
-static void fix_stream_ids(AVFormatContext *s)
+static void fix_stream_ids(AVFormatContext* s)
 {
     int highest_id = 0;
 
     for (int i = 0; i < s->nb_streams; i++) {
-        const AVStream *st = s->streams[i];
-        const MOVStreamContext *sc = st->priv_data;
+        const AVStream* st = s->streams[i];
+        const MOVStreamContext* sc = st->priv_data;
         if (!sc->iamf)
             highest_id = FFMAX(highest_id, st->id);
     }
     highest_id += !highest_id;
     for (int i = 0; highest_id > 1 && i < s->nb_stream_groups; i++) {
-        AVStreamGroup *stg = s->stream_groups[i];
+        AVStreamGroup* stg = s->stream_groups[i];
         if (stg->type != AV_STREAM_GROUP_PARAMS_IAMF_AUDIO_ELEMENT)
             continue;
         for (int j = 0; j < stg->nb_streams; j++) {
-            AVStream *st = stg->streams[j];
-            MOVStreamContext *sc = st->priv_data;
+            AVStream* st = stg->streams[j];
+            MOVStreamContext* sc = st->priv_data;
             st->id += highest_id;
             sc->iamf_stream_offset = highest_id;
         }
     }
 }
 
-static int mov_read_header(AVFormatContext *s)
+static int mov_read_header(AVFormatContext* s)
 {
-    MOVContext *mov = s->priv_data;
-    AVIOContext *pb = s->pb;
+    MOVContext* mov = s->priv_data;
+    AVIOContext* pb = s->pb;
     int j, err;
     MOVAtom atom = { AV_RL32("root") };
     int i;
@@ -10780,6 +10733,7 @@ static int mov_read_header(AVFormatContext *s)
 
     mov->fc = s;
     mov->trak_index = -1;
+    mov->thmb_item_id = NULL;
     mov->primary_item_id = -1;
     mov->cur_item_id = -1;
     /* .mov and .mp4 aren't streamable anyway (only progressive download if moov is before mdat) */
@@ -10797,7 +10751,7 @@ static int mov_read_header(AVFormatContext *s)
             return err;
         }
     } while ((pb->seekable & AVIO_SEEKABLE_NORMAL) &&
-             !mov->found_moov && (!mov->found_iloc || !mov->found_iinf) && !mov->moov_retry++);
+        !mov->found_moov && (!mov->found_iloc || !mov->found_iinf) && !mov->moov_retry++);
     if (!mov->found_moov && !mov->found_iloc && !mov->found_iinf) {
         av_log(s, AV_LOG_ERROR, "moov atom not found\n");
         return AVERROR_INVALIDDATA;
@@ -10820,21 +10774,22 @@ static int mov_read_header(AVFormatContext *s)
         for (i = 0; i < s->nb_streams; i++)
             if (s->streams[i]->codecpar->codec_tag == AV_RL32("tmcd")) {
                 mov_read_timecode_track(s, s->streams[i]);
-            } else if (s->streams[i]->codecpar->codec_tag == AV_RL32("rtmd")) {
+            }
+            else if (s->streams[i]->codecpar->codec_tag == AV_RL32("rtmd")) {
                 mov_read_rtmd_track(s, s->streams[i]);
             }
     }
 
     /* copy timecode metadata from tmcd tracks to the related video streams */
     for (i = 0; i < s->nb_streams; i++) {
-        AVStream *st = s->streams[i];
-        MOVStreamContext *sc = st->priv_data;
+        AVStream* st = s->streams[i];
+        MOVStreamContext* sc = st->priv_data;
         if (sc->timecode_track > 0) {
-            AVDictionaryEntry *tcr;
+            AVDictionaryEntry* tcr;
             int tmcd_st_id = -1;
 
             for (j = 0; j < s->nb_streams; j++) {
-                MOVStreamContext *sc2 = s->streams[j]->priv_data;
+                MOVStreamContext* sc2 = s->streams[j]->priv_data;
                 if (sc2->id == sc->timecode_track)
                     tmcd_st_id = j;
             }
@@ -10854,10 +10809,10 @@ static int mov_read_header(AVFormatContext *s)
         return err;
 
     for (i = 0; i < s->nb_streams; i++) {
-        AVStream *st = s->streams[i];
-        FFStream *const sti = ffstream(st);
-        MOVStreamContext *sc = st->priv_data;
-        uint32_t dvdsub_clut[FF_DVDCLUT_CLUT_LEN] = {0};
+        AVStream* st = s->streams[i];
+        FFStream* const sti = ffstream(st);
+        MOVStreamContext* sc = st->priv_data;
+        uint32_t dvdsub_clut[FF_DVDCLUT_CLUT_LEN] = { 0 };
         fix_timescale(mov, sc);
 
         /* Set the primary extradata based on the first Sample if it doesn't reference the first stsd entry. */
@@ -10875,15 +10830,15 @@ static int mov_read_header(AVFormatContext *s)
         }
 
         if (st->codecpar->codec_type == AVMEDIA_TYPE_AUDIO &&
-            st->codecpar->codec_id   == AV_CODEC_ID_AAC) {
+            st->codecpar->codec_id == AV_CODEC_ID_AAC) {
             sti->skip_samples = sc->start_pad;
         }
         if (st->codecpar->codec_type == AVMEDIA_TYPE_VIDEO && sc->nb_frames_for_fps > 0 && sc->duration_for_fps > 0)
             av_reduce(&st->avg_frame_rate.num, &st->avg_frame_rate.den,
-                      sc->time_scale*(int64_t)sc->nb_frames_for_fps, sc->duration_for_fps, INT_MAX);
+                sc->time_scale * (int64_t)sc->nb_frames_for_fps, sc->duration_for_fps, INT_MAX);
         if (st->codecpar->codec_type == AVMEDIA_TYPE_SUBTITLE) {
             if (st->codecpar->width <= 0 || st->codecpar->height <= 0) {
-                st->codecpar->width  = sc->width;
+                st->codecpar->width = sc->width;
                 st->codecpar->height = sc->height;
             }
             if (st->codecpar->codec_id == AV_CODEC_ID_DVD_SUBTITLE &&
@@ -10900,13 +10855,13 @@ static int mov_read_header(AVFormatContext *s)
                 st->codecpar->extradata_size = 0;
 
                 err = ff_dvdclut_palette_extradata_cat(dvdsub_clut, FF_DVDCLUT_CLUT_SIZE,
-                                                       st->codecpar);
+                    st->codecpar);
                 if (err < 0)
                     return err;
             }
         }
         if (mov->handbrake_version &&
-            mov->handbrake_version <= 1000000*0 + 1000*10 + 2 &&  // 0.10.2
+            mov->handbrake_version <= 1000000 * 0 + 1000 * 10 + 2 &&  // 0.10.2
             st->codecpar->codec_id == AV_CODEC_ID_MP3) {
             av_log(s, AV_LOG_VERBOSE, "Forcing full parsing for mp3 stream\n");
             sti->need_parsing = AVSTREAM_PARSE_FULL;
@@ -10915,14 +10870,14 @@ static int mov_read_header(AVFormatContext *s)
 
     if (mov->trex_data || mov->use_mfra_for > 0) {
         for (i = 0; i < s->nb_streams; i++) {
-            AVStream *st = s->streams[i];
-            MOVStreamContext *sc = st->priv_data;
+            AVStream* st = s->streams[i];
+            MOVStreamContext* sc = st->priv_data;
             if (sc->duration_for_fps > 0) {
                 /* Akin to sc->data_size * 8 * sc->time_scale / sc->duration_for_fps but accounting for overflows. */
-                st->codecpar->bit_rate = av_rescale(sc->data_size, ((int64_t) sc->time_scale) * 8, sc->duration_for_fps);
+                st->codecpar->bit_rate = av_rescale(sc->data_size, ((int64_t)sc->time_scale) * 8, sc->duration_for_fps);
                 if (st->codecpar->bit_rate == INT64_MIN) {
                     av_log(s, AV_LOG_WARNING, "Overflow during bit rate calculation %"PRId64" * 8 * %d\n",
-                           sc->data_size, sc->time_scale);
+                        sc->data_size, sc->time_scale);
                     st->codecpar->bit_rate = 0;
                     if (s->error_recognition & AV_EF_EXPLODE)
                         return AVERROR_INVALIDDATA;
